import math

def dot(v1, v2):
	return v1[0]*v2[0] + v1[1]*v2[1] + v1[2]*v2[2]

def deg(v1, v2):
	return math.acos(dot(v1, v2) / math.sqrt(dot(v1, v1) * dot(v2, v2)))

eps = 1e-9

while True:
	a1, a2, a3 = list(map(int, input().strip().split()))
	if a1+a2+a3==0:
		break
	b1, b2, b3 = list(map(int, input().strip().split()))
	c1, c2, c3 = list(map(int, input().strip().split()))
	
	x, y, z = list(map(int, input().strip().split()))
	
	
	input()
	
	AP = (x - a1, y - a2, z - a3)
	AB = (b1-a1, b2-a2, b3-a3)
	
	AC = (c1-a1, c2-a2, c3-a3)
	
	BA = (a1-b1, a2-b2, a3-b3)
	BP = (x-b1, y-b2, z-b3)
	BC = (c1-b1, c2-b2, c3-b3)
	
	
	CB = (b1-c1, b2-c2, b3-c3)
	CA = (a1-c1, a2-c2, a3-c3)
	CP = (x-c1, y-c2, z-c3)
	
	if abs(dot(AB, AB)) < eps and abs(dot(AC, AC)) < eps:
		if abs(dot(AP, AP)) < eps:
			print('YES')
		else:
			print('NO')
		continue
	if abs(dot(AB, AB)) < eps:
		if abs(deg(AP, AC)) < eps and abs(deg(CP, CA)) < eps:
			print('YES')
		else:
			print('NO')
		continue
	
	if abs(dot(AC, AC)) < eps:
		if abs(deg(AP, AB)) < eps and abs(deg(BP, BA)) < eps:
			print('YES')
		else:
			print('NO')
		continue
	
	if abs(dot(BC, BC)) < eps:
		if abs(deg(AP, AB)) < eps and abs(deg(BP, BA)) < eps:
			print('YES')
		else:
			print('NO')
		continue
	
	if abs(dot(AP, AP)) < eps or abs(dot(BP, BP)) < eps or abs(dot(CP, CP)) < eps:
		print('NO')
		continue
	
	
	
	BAP = deg(AP, AB)
	PAC = deg(AP, AC)
	BAC = deg(AB, AC)
	
	ABC = deg(BA, BC)
	ABP = deg(BA, BP)
	PBC = deg(BP, BC)
	
	
	
	BCP = deg(CB, CP)
	ACP = deg(CA, CP)
	ACB = deg(CA, CB)
	
	if BAP < eps or PAC < eps or PBC < eps:
		print('NO')
	elif abs(BAP + PAC - BAC) < eps and abs(ABP + PBC - ABC) < eps and abs(BCP + ACP - ACB) < eps:
		print('YES')
	else:
		print('NO')
	
