#include <iostream>
#include <string>
#include <vector>
#include <bits/stdc++.h>
using namespace std;


int n;

int sum;

int findPair(string& expr, int idx) {
    int ossz = 0;
    int i;
    for (i = idx + 1; expr[i] != ')' || ossz != 0; i++) {
        if (expr[i] == '(')
            ossz++;
        if (expr[i] == ')')
            ossz--;
    }
    return i;
}

vector<int> v;
vector<char> betuk;

class Calculator {
public:
    int get(string expr)
    {
       // cout << expr << "X" << endl;
        if (expr.size() == 1) {
            for (int i = 0; i < (int)betuk.size(); i++)
                if (betuk[i] == expr[0])
                    return v[i];
        }
        int balk, balv;
        int jobbk, jobbv;
        int separ;

        if (expr[0] == '(') {
            balk = 1;
            balv = findPair(expr, 0);
            separ = balv + 1;
        } else {
            balk = 0;
            balv = 1;
            separ = 1;
        }
        jobbk = separ + 1;
        jobbv = expr.size();
        if (jobbk > expr.size())
            return get(expr.substr(1, expr.size() - 2));
        if (expr[separ] == '+')
            return get(expr.substr(balk, balv - balk)) + get(expr.substr(jobbk, jobbv - jobbk));
        if (expr[separ] == '-')
            return get(expr.substr(balk, balv - balk)) - get(expr.substr(jobbk, jobbv - jobbk));
        if (expr[separ] == '*')
            return get(expr.substr(balk, balv - balk)) * get(expr.substr(jobbk, jobbv - jobbk));
        if (expr[separ] == '/')
            return get(expr.substr(balk, balv - balk)) / get(expr.substr(jobbk, jobbv - jobbk));
        return -1;
    }
};

int main()
{
    /*/
    string tesztem;
    cin >> tesztem;

    v.push_back(1);
    v.push_back(2);
    v.push_back(3);
    v.push_back(4);
    v.push_back(5);


    Calculator calc;
    cout << calc.get(tesztem) << endl;
    //*/
    betuk.push_back('a');
    betuk.push_back('b');
    betuk.push_back('c');
    betuk.push_back('d');
    betuk.push_back('e');

    Calculator calc;
    while( true )
    {
        v.clear();

        cin >> n;
        if( n == 0 )
            break;
        for( int i = 0; i < n; ++i)
        {
            int a;
            cin >> a;
            v.push_back(a);
        }


        cin >> sum;

        string expr;

        cin >> expr;

        sort( v.begin(), v.end() );

        int ok = 0;
        do
        {
            int res = calc.get(expr);
            //cout << res << endl;
            if( res == sum )
            {
                cout << "YES";
                ok = 1;
                break;
            }
        }while( next_permutation(v.begin(), v.end()) );
        if( !ok )
            cout << "NO";

        cout << "\n";
    }

    return 0;
}
