#include <iostream>
#include <vector>

/*
3
2 2 1
3
-1 1 1
1
-1
4
0 0 0 0
4
0 -1 0 0
0

3
2
0
4
0
*/
using namespace std;

class XX {
	const vector<long long>& ref;
	vector<int> minstack;
public:
	XX(vector<long long>& ref) : ref(ref) {}

	void ki(int idx) {
		if (minstack.back() == idx) {
			minstack.pop_back();
		}
	}
	void be(int idx) {
		if (minstack.empty()) {
			minstack.push_back(idx);
		}
		int last_element = ref[minstack.back()];
		int this_element = ref[idx];
		if (last_element > this_element) {
			minstack.push_back(idx);
		}
	}
	long long min() {
		return ref[minstack.back()];
	}
};

void solve(int N) {
	vector<long long> V(N);
	for (long long& be : V) cin >> be;
	vector<long long> S(2 * N+1);
	S[0] = 0;
	XX X(S);
	for (int i = 0; i < 2 * N; i++) {
		S[i + 1] = S[i] + V[i%N];
	}
	for (int i = 2*N; i >= N; i--) {
		X.be(i);
	}
	int s = 0;
	for (int i = N - 1; i >= 0; i--) {
		if (X.min() >= S[i]) {
			s++;
		}
		X.ki(i + N);
		X.be(i);
	}
	cout << s << endl;
}

int main()
{
	cin.sync_with_stdio(false);
	cin.tie(nullptr);
	while (true) {
		int N;
		cin >> N;
		if (N == 0)
			return 0;
		solve(N);
	}
}