#include <iostream>
#include <vector>
#include <string>
#include <sstream>

using namespace std;

struct assem {
	int char1;
	int char2;
	int cost;
};
int main()
{
	int K;
	cin >> K;
	while (K!=0)
	{
		vector<char> letters(256);
		vector<char> iletters(256);
		vector<vector<assem>> assembly(K); //kls dimenzi 26 hossz

		for (int i = 0; i < K; i++) {
			string s;
			cin >> s;
			// length==1
			letters[s[0]] = i;
			iletters[i] = s[0];
		}

		for (int bal = 0; bal < K; bal++) {
			for (int jobb = 0; jobb < K; jobb++) {
				string s;
				cin >> s;
				// s[:-3], s[-1]
				char mi_lesz = letters[s.back()];
				s = s.substr(0,s.size()-2);
				stringstream ss(s);
				int szam = 0;
				ss >> szam;

				assembly[mi_lesz].push_back({ bal, jobb, szam });
			}
		}
		int Query;
		cin >> Query;

		for (int s = 0; s < Query; s++)
		{
			string S;
			cin >> S;
			int Slen = S.size();
			for (char& c : S) c = letters[c];
			
			vector<vector<vector<int>>> D(Slen, vector<vector<int>>(Slen, vector<int>(K, 1000000000)));
			for (int i = Slen-1; i >=0; i--)
			{
				D[i][i][S[i]] = 0;
				for (int j = i+1; j < Slen; j++)
				{
					for (int k = 0; k < K; k++) {
						int min = 1000000000;
						for (assem& a : assembly[k]) {
							for (int l = i; l < j; l++) {
								int cost = D[i][l][a.char1] + D[l + 1][j][a.char2] + a.cost;
								if (min > cost) min = cost;
							}
						}
						D[i][j][k] = min;
					}
				}
			}

			int min = 2000000000, mi = 0;
			for (int k = 0; k < K; k++) {
				int val = D[0][Slen - 1][k];
				if (val < min) { min = val; mi = k; }
			}

			cout << min << "-" << iletters[mi] << endl;
		}
		cin >> K;
		if (K != 0)
			cout << endl;
	}

}
/*
2
a b
3-b 5-b
6-a 2-b
2
aba
bba
2
m e
5-e 4-m
3-e 4-m
1
eme
0
*/