#include <iostream>
#include <algorithm>

using namespace std;

int nx, ny;
double w, x[1005], y[1005];

bool Check(double a[], int n, int l, int r) {
    double cur_r = l;
    for(int i = 0; i < n; ++i) {
        double t1 = a[i] - w / 2;
        double t2 = a[i] + w / 2;
        if (t1 <= cur_r) {
            cur_r = max(cur_r, t2);
        } else {
            return false;
        }
    }
    return cur_r >= r;
}

int main()
{
    ios_base::sync_with_stdio(false);
    while (cin >> nx >> ny >> w) {
        if (nx == 0)
            break;
        for(int i = 0; i < nx; ++i) cin >> x[i];
        for(int i = 0; i < ny; ++i) cin >> y[i];
        sort(x, x + nx);
        sort(y, y + ny);
        if (Check(x, nx, 0, 75))
        if (Check(y, ny, 0, 100)) {
            cout << "YES\n";
            continue;
        }
        cout << "NO\n";
    }
    return 0;
}
