#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

void frissit(vector<pair<int, int>>& min, int j, int i, int m) {
	while (min.size() > j && min.back().second > m) {
		min.pop_back();
	}
	min.emplace_back(i, m);
}

int main() {
	int n;
	while (cin >> n, n) {
		vector<int> szamok(n);
		for (int& x : szamok) {
			cin >> x;
		}
		vector<pair<int, int>> min;
		min.emplace_back(0, 0);
		int o = 0;
		for (int i = 0; i < n; i++) {
			frissit(min, 0, i + 1, o += szamok[i]);
		}
		int j = 0;
		for (int i = 0; i < n; i++) {
			if (min[j].first == i) {
				j++;
			}
			frissit(min, j, n + i + 1, o += szamok[i]);
		}
		cout << j << "\n";
	}
}