#include <iostream>
#include <vector>
#include <string>

using namespace std;

const int N_MAX = 201;
const int K_MAX = 26;

int min[N_MAX][N_MAX][K_MAX];
int ido[K_MAX][K_MAX];
int betu[K_MAX][K_MAX];

int main() {
	ios::sync_with_stdio(true);
	int K;
	bool elso = true;
	while (cin >> K, K) {
		if (!elso) cout << "\n";
		elso = false;
		vector<char> szimbolum(K);
		for (char& c : szimbolum) {
			cin >> c;
		}
		for (int i = 0; i < K; i++) {
			for (int j = 0; j < K; j++)
			{
				char c;
				scanf("%d-%c", &ido[i][j], &c);
				for (int l = 0; l < K; l++) {
					if (c == szimbolum[l]) {
						betu[i][j] = l;
						break;
					}
				}
			}
		}
		int N;
		cin >> N;
		while (N--) {
			string s2;
			cin >> s2;
			vector<int> s(s2.size());
			for (int j = 0; j < s2.size(); j++) {
				for (int i = 0; i < K; i++) {
					if (s2[j] == szimbolum[i]) {
						s[j] = i;
						break;
					}
				}
			}
			int n = s.size();
			for (int i = 0; i < n; i++) {
				for (int l = 0; l < K; l++) {
					min[i][i + 1][l] = -1;
				}
				min[i][i + 1][s[i]] = 0;
			}
			for (int i = n - 1; i >= 0; i--) {
				for (int j = i + 2; j <= n; j++) {
					for (int l = 0; l < K; l++) {
						min[i][j][l] = -1;
					}
					for (int k = i + 1; k < j; k++) {
						for (int l1 = 0; l1 < K; l1++) {
							for (int l2 = 0; l2 < K; l2++) {
								int m1 = min[i][k][l1];
								int m2 = min[k][j][l2];
								if (m1 == -1 || m2 == -1)
									continue;
								if (min[i][j][betu[l1][l2]] == -1 ||
									min[i][j][betu[l1][l2]] > m1 + m2 + ido[l1][l2]) {
									min[i][j][betu[l1][l2]] = m1 + m2 + ido[l1][l2];
								}
							}
						}
					}
				}
			}
			int m = min[0][n][0];
			for (int l = 0; l < K; l++) {
				if (m > min[0][n][l] && min[0][n][l] != -1) {
					m = min[0][n][l];
				}
			}
			for (int l = 0; l < K; l++) {
				if (min[0][n][l] == m) {
					cout << m << '-' << szimbolum[l] << '\n';
					break;
				}
			}
		}
	}

}