#include <iostream>
#include <algorithm>

using namespace std;
using ll = long long;

ll det(ll sz[9]) {
	return sz[0] * sz[4] * sz[8] + sz[1] * sz[5] * sz[6] + sz[2] * sz[3] * sz[7]
		- sz[2] * sz[4] * sz[6] - sz[0] * sz[5] * sz[7] - sz[1] * sz[3] * sz[8];
}

bool kozte(ll a, ll b, ll c, ll x) {
	ll t[3] = { a, b, c };
	sort(t, t + 3);
	return (t[0] < x && x < t[2]);
}

int sgn(ll a) {
	return a > 0 ? 1 : a < 0 ? -1 : 0;
}

int oldal(ll a[3], ll b[3], ll c[3]) {
	return sgn((b[0] - a[0]) * (c[1] - a[1]) - (b[1] - a[1]) * (c[0] - a[0]));
}

bool megold(ll sz[9], ll x, ll y, ll z) {
	ll d = det(sz);
	if (d == 0) {
		if (sz[0] == sz[3] && sz[0] == sz[6] && sz[1] == sz[4] && sz[1] == sz[7] && sz[2] == sz[5] && sz[2] == sz[8]) {
			return x == sz[0] && y == sz[1] && z == sz[2];
		}
		return
			kozte(sz[0], sz[3], sz[6], x) ||
			kozte(sz[1], sz[4], sz[7], y) ||
			kozte(sz[2], sz[5], sz[8], z);
	}
	ll p[3] = { x, y, z };
	int o = oldal(sz, sz + 3, sz + 6);
	return oldal(sz, sz + 3, p) == o &&
		oldal(sz + 3, sz + 6, p) == o &&
		oldal(sz + 6, sz, p) == o;
}

int main() {
	ll sz[9];
	while (1) {
		for (int i = 0; i < 3; i++)
		{
			cin >> sz[i];
		}
		if (sz[0] + sz[1] + sz[2] == 0)
			return 0;
		for (int i = 3; i < 9; i++)
		{
			cin >> sz[i];
		}

		int x, y, z;
		cin >> x >> y >> z;
		cout << (megold(sz, x, y, z) ? "YES\n" : "NO\n");
	}
}