#include <iostream>
#include <algorithm>
#include <vector>

using namespace std;

int main()
{
    ios_base::sync_with_stdio(false);
    vector <int> starts;
    vector <int> ends;
    starts.resize(10001);
    ends.resize(10001);
    int N, M, trash;
    int Mstart, Mend;
    cin >> N >> M;
    do
    {
        starts[N] = 2147483647;
        ends[N] = 2147483647;
        for (int i=0;i<N;i++)
        {
            cin >> trash >> trash;
            cin >> starts[i];
            cin >> trash;
            ends[i] = starts[i] + trash;
        }
        sort(starts.begin(), starts.begin() + N + 1);
        sort(ends.begin(), ends.begin() + N + 1);
        /*for (int i=0;i<=N;i++)
        {
            cout << ends[i] << " ";
        }
        cout << endl;*/
        for (int i=0;i<M;i++)
        {
            cin >> Mstart >> Mend;
            Mend += Mstart;
            Mstart++;
            auto p1 = lower_bound(starts.begin(), starts.begin() + N + 1, Mend);
            auto p2 = lower_bound(ends.begin(), ends.begin() + N + 1, Mstart);
            int k1 = distance(starts.begin(), p1);
            //cout << k1 << endl;
            int k2 = distance(ends.begin(), p2);
            //cout << k2 << endl;
            cout << k1 - k2 << endl;
        }
        cin >> N >> M;
    } while (N != 0);
    return 0;
}

/**
3 2
3 4 2 5
1 2 0 10
6 5 5 8
**/
