#include <iostream>
#include <cmath>

using namespace std;

double angle(double a, double b, double c2)
{
    return acos((a*a + b*b - c2) / (2 * a * b));
}

double dist2(int A[3], int B[3])
{
    return pow(A[0] - B[0], 2) + pow(A[1] - B[1], 2) + pow(A[2] - B[2], 2);
}

int main()
{
    int P1[3], P2[3], P3[3], Q[3];
    double angleSum;
    double P1Q, P2Q, P3Q, P1P2, P1P3, P2P3;
    cin >> P1[0] >> P1[1] >> P1[2]; /// P1
    do
    {
        cin >> P2[0] >> P2[1] >> P2[2]; /// P2
        cin >> P3[0] >> P3[1] >> P3[2]; /// P3
        cin >> Q[0] >> Q[1] >> Q[2]; /// Q
        P1Q = dist2(P1, Q);
        P2Q = dist2(P2, Q);
        P3Q = dist2(P3, Q);
        P1P2 = dist2(P1, P2);
        P1P3 = dist2(P1, P3);
        P2P3 = dist2(P2, P3);
        angleSum = angle(sqrt(P1Q), sqrt(P2Q), P1P2) +
            angle(sqrt(P1Q), sqrt(P3Q), P1P3) +
            angle(sqrt(P2Q), sqrt(P3Q), P2P3);
        //cout << angleSum << endl;
        if (P1P2 == 0 && P1P3 == 0 && P2P3 == 0)
        {
            if (P1Q == 0)
            {
                cout << "YES" << endl;
            }
            else
            {
                cout << "NO" << endl;
            }
        }
        /*else if (P1P2 + P2P3 == P1P3 || P1P2 + P1P3 == P2P3 || P2P3 + P1P3 == P2P3)
        {
            if (P1Q == 0)
            {
                cout << "YES" << endl;
            }
            else
            {
                cout << "NO" << endl;
            }
        }*/
        else
        {
            if (6.28318 < angleSum && angleSum < 6.2832 &&
                P1Q + P2Q != P1P2 && P1Q + P3Q != P1P3 && P2Q + P3Q != P2P3)
            {
                cout << "YES" << endl;
            }
            else
            {
                cout << "NO" << endl;
            }
        }

        cin >> P1[0] >> P1[1] >> P1[2]; /// P1
    } while (P1[0] + P1[1] + P1[2] != 0);
    return 0;
}
