#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

int main()
{
	cin.tie(NULL);
	ios::sync_with_stdio(false);

	int n, m;
	while (true)
	{
		cin >> n >> m;
		if (n == 0 && m == 0) break;

		vector<int> starts;
		vector<int> ends;

		starts.resize(n);
		ends.resize(n);

		for (int i = 0; i < n; ++i) {
			int dummy1, dummy2;
			int duration;

			cin >> dummy1 >> dummy2 >> starts[i] >> duration;
			ends[i] = starts[i] + duration - 1;
		}
		sort(begin(starts), end(starts));
		sort(begin(ends), end(ends));
		for (int i = 0; i < m; ++i) {
			int eleje, vege;
			cin >> eleje >> vege;
			vege = eleje + vege - 1;

			auto vege_elott = distance(begin(starts), std::upper_bound(begin(starts), end(starts), vege));
			auto eleje_elott = distance(begin(ends), std::upper_bound(begin(ends), end(ends), eleje-1));
			std::cout << vege_elott - eleje_elott << '\n';
		}
	}
}