#include <iostream>
#include <vector>

using namespace std;

double Determinant(vector<vector<double>> v)
{
    return v[0][0]*(v[1][1]*v[2][2] - v[1][2]*v[2][1]) - v[0][1]*(v[1][0]*v[2][2] - v[1][2]*v[2][0]) + v[0][3]*(v[1][0]*v[2][1] - v[1][1]*v[2][0]);
}

int main()
{
    cin.sync_with_stdio(false);
    cin.tie(0);

    vector<double> refe = {0.0, 0.0, 0.0};

    vector<vector<double>> ell(3,vector<double>(3));

    while(true)
    {
        vector<vector<double>> t(3, vector<double>(3)), t2;
        for(int i = 0; i < 3; i++)
        {
            for(int j = 2; j >= 0; j--)
                cin>>t[j][i];
            if(i == 0 && t[0][0] == 0.0 && t[1][0] == 0.0 && t[2][0] == 0.0)
                return 0;
        }

        double a, b, c, d1,d2,d3,d4;
        cin>>a>>b>>c;

        d1 = Determinant(t);

        t2 = t;
        t2[2][0] = a;
        t2[1][0] = b;
        t2[0][0] = c;

        d2 = Determinant(t2);
        t2 = t;

        t2[2][1] = a;
        t2[1][1] = b;
        t2[0][1] = c;

        d3 = Determinant(t2);
        t2 = t;

        t2[2][2] = a;
        t2[1][2] = b;
        t2[0][2] = c;

        d4 = Determinant(t2);

        //cout<<d1<<" "<<d2<<" "<<d3<<" "<<d4<<"\n";

        double a2,b2,c2;
        if(d1 == 0 /*&& a == b && b == c*/)
        {
            ell=t;
            for(int i=0;i<3;i++)
            {
                for(int e=0;e<3;e++)
                {
                    for(int j=0;j<3;j++)
                    {
                        for(int k=0;k<3;k++)
                        {
                            if(j!=i&&k!=e)
                            {
                                ell[i][e]*=t[j][k];
                            }
                        }
                    }
                }
            }
            for(int j=0;j<3;j++)
            {
                for(int k=0;k<3;k++)
                {
                    if(j!=2)
                    {
                        a2*=t[j][k];
                    }
                }
            }
            for(int j=0;j<3;j++)
            {
                for(int k=0;k<3;k++)
                {
                    if(j!=1)
                    {
                        b2*=t[j][k];
                    }
                }
            }
            for(int j=0;j<3;j++)
            {
                for(int k=0;k<3;k++)
                {
                    if(j!=0)
                    {
                        c2*=t[j][k];
                    }
                }
            }
            if(c2!=b2||b2!=a2||c2!=a2)
            {
                cout<<"NO"<<"\n";
                continue;
            }
            cout<<"YES"<<"\n";
            continue;
        }

        if(d2/d1 + d3/d1 + d4/d1 == 1.0)
            cout<<"YES\n";
        else
            cout<<"NO\n";
    }
    return 0;
}
