#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

bool check(const vector<long long int>& x, long long int w)
{
    pair<long long int,long long int> lastInterval;
    lastInterval.first=0;
    lastInterval.second=0;

    for (int i=0; i<x.size(); ++i){
        pair<long long int,long long int> interval;
        interval.first=x[i]-w;
        interval.second=x[i]+w;
        // cout << interval.first / 10000000.0 << " " << interval.second / 10000000.0 << endl;

        if (interval.first<=lastInterval.second){
            lastInterval.first = interval.first;
            lastInterval.second = interval.second;
        } else {
            return false;
        }
    }

    return true;
}

int main(){
    ios::sync_with_stdio(false);
    

    while(1){
        long long int nx;
        long long int ny;
        double ws;
        cin>>nx>>ny>>ws;
        if (nx==0 && ny==0 && ws==0){
            break;
        }

        long long int w = ws * (10000000/2);

        vector<long long int> x;
        vector<long long int> y;

        for (int i=0; i<nx; ++i){
            double act;
            cin>>act;
            long long int ins = act * 10000000;
            x.push_back(ins);
        }

        for (int i=0; i<ny; ++i){
            double act;
            cin>>act;
            long long int ins = act * 10000000;
            y.push_back(ins);
        }

        // cout<<"NX: "<<nx<<endl;
        // cout<<"NY: "<<ny<<endl;
        // cout<<"W: "<<w<<endl;

        x.push_back(75 * 10000000 + w);
        y.push_back(100 * 10000000 + w);

        sort(x.begin(),x.end());
        sort(y.begin(),y.end());


        // pair<long long int,long long int> lastInterval;
        // lastInterval.first=0;
        // lastInterval.second=0;
        // bool breaked = false;

        // for (int i=0; i<nx; ++i){
        //     pair<long long int,long long int> interval;
        //     interval.first=x[i]-w;
        //     interval.second=x[i]+w;
        //     cout << interval.first << " " << interval.second << endl;

        //     if (interval.first<=lastInterval.second){
        //         lastInterval.first = interval.first;
        //         lastInterval.second = interval.second;
        //     } else {
        //         breaked = true;
        //         break;
        //     }
        // }

        // if (breaked){
        //     cout<<"NO"<<endl;
        // } else {
        //     lastInterval.first=0;
        //     lastInterval.second=0;
        //     breaked = false;

        //     for (int i=0; i<ny; ++i){
        //         pair<long long int,long long int> interval;
        //         interval.first=y[i]-w;
        //         interval.second=y[i]+w;

        //         if (interval.first<=lastInterval.second){
        //             lastInterval.first = interval.first;
        //             lastInterval.second = interval.second;
        //         } else {
        //             breaked = true;
        //             break;
        //         }
        //     }

        //     if (breaked){
        //         cout<<"NO"<<endl;

        //     } else {
        //         cout<<"YES"<<endl;
        //     }
        // }
        if(check(x, w) && check(y, w)) cout << "YES" << endl;
        else cout << "NO" << endl;
        // cout << endl << endl;

    }
}