#include <iostream>
#include <vector>
#include <map>
#include <sstream>

#define __INT__MAX__ 2000000000;

using namespace std;

struct S {
    int time;
    int ord;


};

string fun(const string& s, const vector< vector<S> >& xs, const map<char, int>& ords, const map<int, char>& chrs)
{
    vector< vector<S> > ys(s.size(), vector<S>(s.size()));

    for(int i = 0; i < s.size(); ++i) {
        ys[i][i] = {0, ords.at(s[i])};
    }

    for(int k = 1; k < s.size(); ++k) {
        for(int i = 0; i + k < s.size(); ++i) {
            int minK = 0;
            ys[i][i+k].time = __INT__MAX__;
            for(int j = 0; j < k; ++j) {
                if( (ys[i][i+j].time + ys[i+j+1][i+k].time + xs[ ys[i][i+j].ord ][ ys[i+j+1][i+k].ord ].time) < ys[i][i+k].time ){
                    minK = i+j;
                    ys[i][i+k].time = (ys[i][i+j].time + ys[i+j+1][i+k].time + xs[ ys[i][i+j].ord ][ ys[i+j+1][i+k].ord ].time);
                    ys[i][i+k].ord = xs[ ys[i][i+j].ord ][ ys[i+j+1][i+k].ord ].ord;
                }
                else if((ys[i][i+j].time + ys[i+j+1][i+k].time + xs[ ys[i][i+j].ord ][ ys[i+j+1][i+k].ord ].time) == ys[i][i+k].time) {
                    ys[i][i+k].ord = min(ys[i][i+k].ord, xs[ ys[i][i+j].ord ][ ys[i+j+1][i+k].ord ].ord);
                }
            }

        }
    }

    stringstream ss;
    ss << ys[0][s.size()-1].time << "-" << chrs.at(ys[0][s.size()-1].ord);
    return ss.str();
}

int main(){
while(1) {
    int k;
    cin >> k;

    if(k == 0) break;

    map<char, int> ords;
    map<int, char> chrs;
    for(int i = 0; i < k; ++i) {
        char c;
        cin >> c;
        ords[c] = i;
        chrs[i] = c;
    }
    // cout << "asd" << endl;

    vector< vector<S> > xs(k, vector<S>(k));

    for(int i = 0; i < k; ++i) {
        for(int j = 0; j < k; ++j) {
            //string tmp;
            int a;
            char tmp2; 
            scanf("%d-%c", &a, &tmp2);
            // cout << a << "-" << tmp2 << endl; 
            //getline(cin, tmp);
            //istringstream ss(tmp);

            //cout << tmp << endl;
            //int time = atoi(tmp.c_str());
            //cin >> tmp2;
            //cout << tmp2 << endl;
            xs[i][j] = {a, ords[tmp2]};
        }
    }

    // for(int i = 0; i < k; ++i) {
    //     for(int j = 0; j < k; ++j) {
    //         cout << xs[i][j].time << "-" << xs[i][j].ord << " ";
    //     }
    //     cout << endl;
    // }

    int num;
    cin >> num;

    for(int i = 0; i < num; ++i) {
        string words;
        cin >> words;
        cout << fun(words, xs, ords, chrs) << endl;
    }
    cout << endl;
}
}