#include <iostream>
#include <vector>
#include <utility>
#include <algorithm>

using namespace std;

struct S {
    S(int _x, int _y, int _ind) : x(_x), y(_y), ind(_ind) {} 
    int x;
    int y;
    int ind;
};

int main()
{
while(1) {
    int n,m;
    cin >> n >> m;
    if(n == 0 && m == 0) break;

    vector< pair<int,int> > xs;
    vector< S > tests;

    for(int i = 0; i < n; ++i) {
        int x,y,tmp;
        cin >> tmp >> tmp >> x >> y;
        xs.push_back({x,x+y});
    }

    for(int i = 0; i < m; ++i) {
        int x,y;
        cin >> x >> y;
        tests.push_back(S(x,x+y,i));
    }

    sort(xs.begin(), xs.end(), [](pair<int,int>& l, pair<int,int>& r){ return l.first < r.first; });

    // for(auto& x : xs) {
    //     cout << x.first << " "  << x.second << endl; 
    // }
    // cout << endl << endl;

    sort(tests.begin(), tests.end(), [](S& l, S& r){ return l.y < r.y; });

    // for(auto& t : tests) {
    //     cout << t.first  << " " << t.second << endl;
    // }
    vector<int> out(m);
    for(auto& t : tests) {
        int acc = 0;
        for(auto& x : xs) {
            if(x.first > t.y) break;
            if(x.first < t.y && x.second > t.x) ++acc;
        }
        out[t.ind] = acc;
    }

    for(int i : out) cout << i << endl;
}

    return 0;
}