#include <bits/stdc++.h>

using namespace std;

int main() {

#ifndef ONLINE_JUDGE	
	freopen("in.1", "r", stdin);
#endif
	
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);
	cout.tie(nullptr);
	
	int nx, ny;
	long double w;
	
	
	
	while (scanf("%d %d %Lf", &nx, &ny, &w) == 3 && (nx > 0 || ny > 0) && w > 0) {
				
		vector<long double> x(nx), y(ny);
		
		w /= 2;
				
		for (int i = 0; i < nx; i++) {
			scanf("%Lf", &x[i]);
		}
		
		for (int i = 0; i < ny; i++) {
			scanf("%Lf", &y[i]);
		}
		
		sort(begin(x), end(x));
		sort(begin(y), end(y));
		
		
		int i = 0;
		bool covered = false;
		long double at = 0;
		
		while (i < nx && fabs(x[i] - at) <= w) {
			at = x[i] + w;
			i += 1;
		}
		
		covered = at >= 75.0;
		
		i = 0;
		at = 0;
		
		while (i < ny && fabs(y[i] - at) <= w) {
			at = y[i] + w;
			i += 1;
		}
		
		covered &= at >= 100.0;
		
		printf("%s\n", covered ? "YES" : "NO");
	}
	
	
		
	return 0;
}


