#include <iostream>
#include <stdio.h>
#include <algorithm>
#include <vector>
#include <set>
#include <map>
#include <cmath>

using namespace std;

string str;
int n, m;
string palindrome;
bool is_palindrome_so_far;

char magic_table[3][10000];

bool is_palindrome(int index, bool left, bool right) {
	if (index >= palindrome.length() - 1 - index) {
		return true;
	}

	bool return_value = false;

	if (index + 1 == palindrome.length() - 1 - index && right && left) {
		return is_palindrome(index, true, false) || is_palindrome(index, false, true);
	}

	if (right && left) {
		for (int i = 0; i < 3; i++) {
			for (int j = 0; j < 3; j++) {
				if (magic_table[j][index] == magic_table[i][palindrome.length() - 1 - index]) {
					return_value = return_value || is_palindrome(index + 1, j == 0, i == 0);
				}
			}
		}
		return return_value;
	} else if (left) {
		for (int i = 0; i < 3; i++) {
			if (magic_table[i][index] == magic_table[0][palindrome.length() - 1 - index]) {
				return_value = return_value || is_palindrome(index + 1, i == 0, true);
			}
		}
		return return_value;
	} else if (right) {
		for (int i = 0; i < 3; i++) {
			if (magic_table[0][index] == magic_table[i][palindrome.length() - 1 - index]) {
				return_value = return_value || is_palindrome(index + 1, true, i == 0);
			}
		}
		return return_value;
	} else if (!right && !left) {
		if (magic_table[0][index] == magic_table[0][palindrome.length() - 1 - index]) {
			return_value = return_value || is_palindrome(index + 1, true, true);
		}
		return return_value;
	}
}

bool switch_chars() {
	
	if (palindrome.length() == 0) return true;

	map<char, char> kovetkezo;
	map<char, char> elozo;

	kovetkezo['A'] = 'G';
	kovetkezo['G'] = 'T';
	kovetkezo['T'] = 'C';
	kovetkezo['C'] = 'A';

	elozo['A'] = 'C';
	elozo['G'] = 'A';
	elozo['T'] = 'G';
	elozo['C'] = 'T';
	for (int i = 0; i < palindrome.length(); i++) {
		magic_table[0][i] = palindrome[i];
		magic_table[1][i] = kovetkezo[palindrome[i]];
		magic_table[2][i] = elozo[palindrome[i]];
	}
/*
	cout << palindrome << endl;
	for (int i = 0; i < 3; i++) {
		for (int j = 0; j < palindrome.length(); j++) {
			cout << magic_table[i][j] << " ";
		}
		cout << endl;
	}
	cout << endl;
*/
	return is_palindrome(0, true, true);
}

int main() {

	while (true) {
		cin >> n >> m;
		if (!n && !m) break;
		str = "";

		cin >> str;
		is_palindrome_so_far = true;

		for (int i = 0; i < m; i++) {
			int numbers;
			cin >> numbers;

			char trash;
			cin >> trash;

			palindrome = "";

			int temp;


			for (int j = 0; j < numbers; j++) {
				cin >> temp;
				palindrome += str[temp];

			}

			is_palindrome_so_far = is_palindrome_so_far && switch_chars();
		}

		if (!is_palindrome_so_far) {
			cout << "NO\n";
		} else {
			cout << "YES\n";
		}
	}


	return 0;
}