import java.util.*;

class Grasscut{
    double width, xLength, yLength, xLastCut, yLastCut;

    public Grasscut(double width) {
        this.width = width;
        xLength = 75;
        yLength = 100;
        xLastCut = 0;
        yLastCut = 0;
    }

    public boolean CutLine(boolean isDirectionX, double center){
        double cutStart = center - width/2;
        if(isDirectionX){
            if(cutStart <= xLastCut){
                xLastCut += width - (xLastCut - cutStart);
                return true;
            }
            return false;
        }else{
            if(cutStart <= yLastCut){
                yLastCut += width - (yLastCut - cutStart);
                return true;
            }
            return false;
        }
    }

    public boolean isXGood() {
        return xLastCut >= xLength;
    }

    public boolean isYGood() {
        return yLastCut >= yLength;
    }
}

public class A {
    public static void main(String[] args) {
        Scanner sc = new Scanner(System.in);
        for (String line = sc.nextLine(); !line.equals("0 0 0.0"); line = sc.nextLine()) {
            String[] data = line.split(" ");
            //Beolvasom a számokat
            int n_x = Integer.parseInt(data[0]);
            int n_y = Integer.parseInt(data[1]);
            double w = Double.parseDouble(data[2]);
            Grasscut gc = new Grasscut(w);
            boolean stillGood = true;
            //Beolvasom a nyírásokat.
            //X
            data = sc.nextLine().split(" ");
            double[] dataInD = new double[n_x];
            for (int i = 0; i < n_x; i++) dataInD[i] = Double.parseDouble(data[i]);
            Arrays.sort(dataInD);
            for (int i = 0; i < n_x && stillGood; i++) stillGood = gc.CutLine(true, dataInD[i]);
            stillGood = gc.isXGood();
            //Y
            data = sc.nextLine().split(" ");
            dataInD = new double[n_y];
            for (int i = 0; i < n_y && stillGood; i++) dataInD[i] = Double.parseDouble(data[i]);
            Arrays.sort(dataInD);
            for (int i = 0; i < n_y && stillGood; i++) stillGood = gc.CutLine(false, dataInD[i]);
            stillGood = gc.isYGood();
            if (stillGood)
                System.out.println("YES");
            else
                System.out.println("NO");
        }
    }
}
