import java.lang.reflect.Array;
import java.util.ArrayList;
import java.util.Scanner;

class City{
    private int people, boxes;
    private double max;

    public City(int people) {
        this.people = people;
        boxes = 1;
        max = people;
    }

    public void addBox(){
        boxes++;
        max = ((double)people) / boxes;
    }

    public double getMax() {
        return max;
    }
}

public class D {

    public static void main(String[] args) {
        Scanner sc = new Scanner(System.in);
        for (String line = sc.nextLine(); !line.equals("-1 -1"); line = sc.nextLine()) {
            String[] data = line.split(" ");
            int numOfC = Integer.parseInt(data[0]);
            int numOfBoxes = Integer.parseInt(data[1]);
            ArrayList<City> cities = new ArrayList<>();
            int sum = 0;
            for (int i = 0; i < numOfC; i++) {
                int p = Integer.parseInt(sc.nextLine());
                cities.add(new City(p));
                sum += p;
            }
            int average = sum / numOfBoxes;
            for (int i = 0; i < numOfBoxes - numOfC; i++) {
                //get the max index
                double max = -1.0;
                int index = -1;
                for (int j = 0; j < cities.size(); j++) {
                    double actualMax = cities.get(j).getMax();
                    if (actualMax < average) {
                        cities.remove(j);
                        j--;
                    } else if (actualMax > max) {
                        max = actualMax;
                        index = j;
                    }
                }
                cities.get(index).addBox();
            }
            //Write out max.
            double max = -1.0;
            for (int j = 0; j < cities.size(); j++) {
                double actualMax = cities.get(j).getMax();
                if (actualMax > max) {
                    max = actualMax;
                }
            }
            System.out.println( (int)Math.ceil(max) );
            line = sc.nextLine();
        }
    }
}
