import java.util.ArrayList;
import java.util.Scanner;

class Hívás{
    int kezdet, vég;

    public Hívás(int kezdet, int időtartam) {
        this.kezdet = kezdet;
        this.vég = kezdet + időtartam;
    }
}

class Vizsgálat{
    int kezdet, vég;

    public Vizsgálat(int kezdet, int időtartam) {
        this.kezdet = kezdet;
        this.vég = kezdet + időtartam;
    }

    public int CountHívasok(ArrayList<Hívás> hivasok){
        int count = 0;
        for(int i = 0; i < hivasok.size(); i++){
            if( (kezdet >= hivasok.get(i).kezdet &&  kezdet < hivasok.get(i).vég) || (vég > hivasok.get(i).kezdet &&  vég <= hivasok.get(i).vég) )
                count++;
        }
        return count;
    }

}

public class I {
    public static void main(String[] args) {
        Scanner sc = new Scanner(System.in);
        for(String tmp  = sc.nextLine(); !tmp.equals("0 0"); tmp  = sc.nextLine()){
            String[] data = tmp.split(" ");
            int n = Integer.parseInt(data[0]);
            int m = Integer.parseInt(data[1]);
            ArrayList<Hívás> hivasok = new ArrayList<>();
            for(int i = 0; i < n; i++){
                String[] h = sc.nextLine().split(" ");
                hivasok.add(new Hívás(Integer.parseInt(h[2]), Integer.parseInt(h[3])));
            }
            for(int i = 0; i < m; i++){
                String[] v = sc.nextLine().split(" ");
                Vizsgálat vizsalat = new Vizsgálat(Integer.parseInt(v[0]), Integer.parseInt(v[1]));
                System.out.println( vizsalat.CountHívasok(hivasok) );
            }
        }

    }
}
