import java.util.ArrayList;
import java.util.Comparator;
import java.util.List;
import java.util.Scanner;
import java.util.stream.Collectors;

import static java.lang.Integer.parseInt;

public class Boxes {
    static class City {
        long popul;
        long boxes;

        City(long popul) {
            this.popul = popul;
            this.boxes = 0;
        }

        void setBoxes(long boxes) {
            this.boxes = boxes;
        }
    }

    public static void main(String[] args) {
        long cities, boxes, temp;
        long sum;

        List<City> adatok = new ArrayList<>();

        Scanner sc = new Scanner(System.in);
        String asd;
        while (sc.hasNextLine()) {
            if ((asd = sc.next()).equals("-1")) break;
            else {
                cities = parseInt(asd);
                boxes = parseInt(sc.next());
            }

            adatok.clear();

            sum = 0;
            for (int i = 0; i < cities; ++i) {
                temp = Long.parseLong(sc.next());
                adatok.add(new City(temp));
                sum += temp;
            }

            adatok = adatok.stream()
                    .sorted(Comparator.comparing(a -> a.popul))
                    .collect(Collectors.toList());

            long boxesPerCity, tempBoxes;
            for (City city : adatok) {
                boxesPerCity = sum / boxes;
                tempBoxes = (long) Math.ceil((double) city.popul / boxesPerCity);
                city.setBoxes(tempBoxes);
                boxes -= tempBoxes;
                sum -= city.popul;
            }

            System.out.println(adatok.get(adatok.size() - 1).popul / adatok.get(adatok.size() - 1).boxes);
        }
    }
}
