import java.util.*;

public class Boxes {
    public static void main(String[] args) {
        int cities, boxes, temp;
        int sum;

        List<Integer> popul = new ArrayList<>();
        List<Integer> boxCount = new ArrayList<>();

        Scanner sc = new Scanner(System.in);
        sc.useLocale(Locale.ENGLISH);

        try {
            while (true) {
                cities = sc.nextInt();
                boxes = sc.nextInt();

                if (cities == -1 && boxes == -1) break;

                popul.clear();
                boxCount.clear();
                sum = 0;

                for (int i = 0; i < cities; ++i) {
                    temp = sc.nextInt();
                    popul.add(temp);
                    sum += temp;
                }
                popul.sort(Comparator.comparing(a -> a));

                int boxesPerCity, tempBoxes;
                for (Integer p : popul) {
                    boxesPerCity = sum / boxes;
                    tempBoxes = (int) Math.ceil((double) p / boxesPerCity);
                    boxCount.add(tempBoxes);
                    boxes -= tempBoxes;
                    sum -= p;
                }

                System.out.println((int)popul.get(popul.size() - 1) / boxCount.get(boxCount.size() - 1));
            }
        }
        catch (Exception ignored) {}
        sc.close();
    }
}
