from sys import stdin, stdout, exit

def toint(decimal):
    asd = decimal.split('.')
    if len(asd) == 1:
        return int(asd[0]) * 10000000
    (upper, lower) = asd
    return int(upper) * 10000000 + int(lower) * pow(10, 7-len(lower))

assert(toint('1.2')==12000000)
assert(toint('1')==10000000)
assert(toint('1.2000000')==12000000)
assert(toint('12.2000000')==122000000)

def test(rows, width, whole):
    next = width//2 # lefele kerekitve
    for r in rows:
        if r > next:
            return False
        next = r + width
    return next >= (width+1)//2 + whole

assert(not test([1,2], 1, 3))
assert(not test([2], 2, 4))
assert(test([1], 2, 2))

def solve(line123):
    line1 = line123[0]
    n, m, w = line1.split(' ')
    n = int(n)
    m = int(m)
    w = toint(w)
    if n == 0:
        exit(0)
    line2 = line123[1]
    line3 = line123[2]

    rows = sorted(map(toint, line2.split(' ')))
    columns = sorted(map(toint, line3.split(' ')))
    if test(rows, w, toint('75.0')) and test(columns, w, toint('100.0')):
        print('YES')
    else:
        print('NO')

def main():
    data = stdin.read().split('\n')
    while True:
        solve(data[:3])
        data = data[3:]

main()

'''
8 11 10.0
0.0 10.0 20.0 30.0 40.0 50.0 60.0 70.0
0.0 10.0 20.0 30.0 40.0 50.0 60.0 70.0 80.0 90.0 100.0
8 10 10.0
0.0 10.0 20.0 30.0 40.0 50.0 60.0 70.0
0.0 10.0 30.0 40.0 50.0 60.0 70.0 80.0 90.0 100.0
4 5 20.0
70.0 10.0 30.0 50.0
30.0 10.0 90.0 50.0 70.0
4 5 20.0
60.0 10.0 30.0 50.0
30.0 10.0 90.0 50.0 70.0
0 0 0.0
'''