#include <iostream>
#include <vector>

using namespace std;

void solve(int N, int B) {
	vector<int> V(N);
	int maxai = -1;
	for (int& be : V) {
		cin >> be;
		if (be > maxai) maxai = be;
	}
	int nagyobb = 0, nemnagyobb = maxai;
	while (nemnagyobb - nagyobb > 1) {
		int pproba = (nemnagyobb + nagyobb) / 2;

		int b = 0;
		for (int a : V) {
			b += (a + pproba - 1) / pproba;
			if (b > B)
				break;
		}
		if (b > B) {
			nagyobb = pproba;
		}
		else {
			nemnagyobb = pproba;
		}
	}
	cout << nemnagyobb << endl;
}

int main()
{
	cin.sync_with_stdio(false);
	cin.tie(nullptr);
	while (true) {
		int N, B;
		cin >> N >> B;
		if (N == -1)
			return 0;
		solve(N, B);
	}
}