#include <iostream>

using namespace std;

int a[500005];
int n;
long long b;

bool Check(int x) {
    long long box = 0;
    for(int i = 0; i < n; ++i) {
        box += (a[i] / x) + (a[i] % x == 0 ? 0 : 1);
        if (box > b) return false;
    }
    return box <= b;
}

int main()
{
    ios_base::sync_with_stdio(false);
    while (cin >> n >> b) {
        if (n == -1)
            break;
        int lo = 1, hi = 0;
        for(int i = 0; i < n; ++i) cin >> a[i], hi = max(hi, a[i]);
        int mid = (lo + hi) / 2;
        while (lo != mid && hi != mid) {
            if (Check(mid)) {
                hi = mid;
            } else {
                lo = mid;
            }
            mid = (lo + hi) / 2;
        }
        for (int i = lo; i <= hi; ++i)
        if (Check(i)) {
            cout << i << '\n';
        }
    }
    return 0;
}
