#include <iostream>
#include <vector>
#include <memory>
#include <algorithm>

; using namespace std

; struct Node {
  ; using ptr = shared_ptr<Node>
  ; ptr left
  ; char op
  ; ptr right
  ; Node(ptr left, char op, ptr right) : left{left}, op{op}, right{right} {}
  ;}

; Node::ptr parse() {
  ; char c
  ; cin >> c
  ; if (c == '(') {
    ; Node::ptr left{parse()}
    ; char op
    ; cin >> op
    ; Node::ptr right{parse()}
    ; char paren
    ; cin >> paren
    ; return make_shared<Node>(Node{left, op, right})
    ;} else {
    ; return nullptr
    ;}
  ;}

; int eval(vector<int> &vs, Node::ptr expr) {
  ; if (expr) {
    ; int left = eval(vs, expr->left)
    ; int right = eval(vs, expr->right)
    ; switch (expr->op) {
      ; case '+': return left + right
      ; case '-': return left - right
      ; case '*': return left * right
      ; default: return 0
      ;}
    ;} else {
    ; int v = vs[vs.size()-1]
    ; vs.pop_back()
    ; return v
    ;}
  ;}

; int main() {
  ; int n
  ; cin >> n
  ; while (n != 0) {
    ; vector<int> vs{}
    ; for (int i{0}; i < n; ++i) {
      ; int v
      ; cin >> v
      ; vs.push_back(v)
      ;}
    ; int m
    ; cin >> m
    ; Node::ptr expr{parse()}
    ; sort(vs.begin(), vs.end())
    ; bool found{false}
    ; do {
      ; vector<int> vs2{vs}
      ; found = eval(vs2, expr) == m
      ;} while (!found && next_permutation(vs.begin(), vs.end()))
    ; if (found) {
      ; cout << "YES\n"
      ;} else {
      ; cout << "NO\n"
      ;}
    ; cin >> n
    ;}
  ;}
