#include <iostream>
using namespace std;

typedef long long ll;

ll mod=10567201;
ll f[1003][1003][2];
ll kh[1005];
ll b[1005][1005];
ll ik[1005];

ll inv(ll a) {
    ll s = 1;
    ll x = mod - 2;
    while(x) {
        if(x & 1) {
            s *= a;
            s %= mod;
        }
        a *= a;
        a %= mod;
        x >>= 1;
    }
    return s;
}

ll fa[1002] = {1, 1};
ll fact(ll n) {
    if(fa[n] != 0) return fa[n];
    else return fa[n] = (fact(n-1) * n ) %mod;
}

int main()
{
    kh[0]=1;
    for(int i=1;i<1002;i++)
    {
        kh[i] = 2*kh[i-1];
        kh[i] %= mod;
    }
    for(int i = 1; i < 1002; ++i) {
        b[i][0] = kh[i];
        for(int j = 1; j < 1002; ++j) {
            b[i][j] = (b[i][j-1] * (kh[i] - j)) % mod;
        }
    }
    for(int i = 1; i < 1002; ++i) {
        f[i][1][0] = 1;
        f[i][1][1] = 1;
        f[i][2][0] = 0;
        f[i][2][1] = kh[i];
    }
    for(int i = 1; i < 1002; ++i) {
        for(int j = 3; j < 1002;++j) {
            f[i][j][0] = (b[i][j-2] + mod - ((f[i][j-2][0] * (j-1) % mod) * (kh[i] - j + 2) % mod))%mod;
            f[i][j][1] = ((b[i][j-1] + mod - f[i][j][0]) % mod) * inv(kh[i]-1) % mod;
        }
    }
    while(true) {
        ll m, n, k;
        cin >> n >> m >> k;
        if(n == 0 && m == 0 && k == 0) break;
        if(n <= 10 && m > kh[n]) cout << 0 << endl;
        else cout << f[n][m][k >= 1 ? 1 : 0] * inv(fact(m)) % mod << endl;
    }
    return 0;
}
