#include <iostream>
#include <bits/stdc++.h>
using namespace std;

bool solvedir(int N, int w, int nw){
    vector<double> midpts(N);
    for (int i=0; i!=N; ++i){
        cin>>midpts[i];
    }
    sort(midpts.begin(),midpts.end());
    double done_until=0;
    for (int x:midpts) {
        if (done_until<x-w/2){
            return 0;
        }
        done_until=x+w/2;
    }
    if (nw>done_until){
        return 0;
    }
    return 1;
}

void solve(int N, int M, int w){
    if (N==0) return;
    bool a,b;
    a=solvedir(N,w,75);
    b=solvedir(M,w,100);
    if (a&&b){
        cout<<"YES\n";
    }else{
        cout<<"NO\n";
    }
}


int main()
{
    ios::sync_with_stdio(0);
    int N,M;
    double w;
    do {
        cin>>N>>M>>w;
        solve(N,M,w);
    } while (N!=0);
    return 0;
}
