#include <iostream>
#include <queue>
#include <vector>

using namespace std;

struct city
{
    int resident, ballot;
    bool operator<(const city better) const
    {
        return resident * better.ballot < better.resident * ballot;
    }
};

int main()
{
    int N, K;
    priority_queue<city> cities;
    city input;
    city actual;
    cin >> N >> K;
    vector<int> sol;
    sol.clear();
    while (N != -1 || K != -1) {
        while (!cities.empty()) {
            cities.pop();
        }
        for (int i = 0; i < N; i++) {
            cin >> input.resident;
            input.ballot = 1;
            cities.push(input);
        }
        K -= N;
        while (K > 0) {
            actual = cities.top();
            cities.pop();
            actual.ballot++;
            cities.push(actual);
            K--;
        }
        actual = cities.top();
        actual.resident += (actual.ballot - 1);
        sol.push_back(actual.resident/actual.ballot);
        cin >> N >> K;
    }
    for (int i = 0; i < sol.size(); i++) {
        cout << sol[i] << endl;
    }
    return 0;
}
