#include <bits/stdc++.h>

using namespace std;

const long long SHIFT = 1E7;


bool check(vector<long long>& T, const long long w, const long long length) {
    //cout << w << "::" << length << endl;
    sort(T.begin(), T.end());
    long long done = 0;
    for (auto sp : T) {
        if (sp - w/2 <= done) {
            //cout << sp << "-" << done << "-" << w/2 << endl;
            done = (sp + w/2);
            //cout << done << endl;
        } else {
            return false;
        }
    }
    return (done >= length);
}


int main(){
    cin.tie(NULL);
    ios::sync_with_stdio(false);

    long double dw;
    long double dpos;
    long nx, ny, w, pos;
    while (cin >> nx >> ny >> dw) {
        w = SHIFT*dw;
        //cout << nx << ny << w << endl;
        if ((nx | ny | w) == 0) break;

        vector<long long> L(nx);
        for (int i = 0; i < nx; ++i) {
            cin >> dpos;
            L[i] = (dpos*SHIFT);
        }
        if (!check(L, w, 75*SHIFT)) {
            cout << "NO\n";
            continue;
        }


        vector<long long> W(ny);
        for (int i = 0; i < ny; ++i) {
            cin >> dpos;
            W[i] = (dpos*SHIFT);
        }
        if (!check(W, w, 100*SHIFT)) {
            cout << "NO\n";
            continue;
        }

        cout << "YES\n";
    }


}