#include <iostream>
#include <queue>
#include <utility>

using namespace std;

int main()
{
	cin.tie(NULL);
	ios::sync_with_stdio(false);


	int n, b;
	while (true) {
		cin >> n >> b;
		if (n == -1) break;
		std::priority_queue<pair<int, pair<int, int>>> q;
		for (int i = 0; i < n; ++i) {
			int tmp;
			cin >> tmp;
			q.push({ tmp, {tmp, 1} });
		}

		for (int i = 0; i < b-n; ++i) {
			auto e = q.top();
			q.pop();

			int total = e.second.first;
			int boxes = e.second.second;
			++boxes;

			q.push({ (total + boxes - 1) / boxes, {total, boxes} });
		}
		cout << q.top().first << std::endl;
	}
}