#include <iostream>
#include <vector>

using namespace std;

struct el{
    int u1, v1, u2, v2;
};

int os[10000] = {}, mely[10000] = {};
vector<el> elek;

int Os(int x)
{
    if(os[x] == -1)
        return x;
    os[x] = Os(os[x]);
    return os[x];
}

bool Union(int a, int b)
{
    a = Os(a);
    b = Os(b);

    if(a == b)
        return false;
    if(mely[a] == mely[b])
    {
        os[a] = b;
        mely[b]++;
    }
    else if(mely[a] < mely[b])
        os[a] = b;
    else
        os[b] = a;
    return true;
}

int main()
{
    cin.sync_with_stdio(false);
    cin.tie(0);

    int n;
    while(cin>>n)
    {
        for(int i = 0; i < 10000; i++)
        {
            os[i] = -1;
            mely[i] = 0;
        }
        if(n == 0)
            break;

        elek.resize(n);
        for(int i = 0; i < n; i++)
            cin>>elek[i].u1>>elek[i].v1>>elek[i].u2>>elek[i].v2;

        int meg = 0;
        for(int i = 0; i < n; i++)
        {
            if(Union(elek[i].u1, elek[i].v1))
                meg++;
            else if(Union(elek[i].u2, elek[i].v2))
                meg++;
        }

        cout<<meg*2<<"\n";
    }

    return 0;
}
