#include <iostream>
#include <map>
#include <vector>
#include <algorithm>
using namespace std;
string s1;
map<char,int> m;
vector<int> sor;
vector<int> volt;
int desired;
bool solved = false;
void bead(){
    m.clear();
    int a = 0;
    for(int i = 0; i < s1.size(); i++){
        if(s1[i] != '*' && s1[i] != '-' && s1[i] != '+' && s1[i] != '(' && s1[i] != ')'){
            m[s1[i]] = sor[a++];
        }
    }
}
int megold(string s){
    string uj;
    int going = -1;
    for(int i = 0; i < s.size(); i++){
        if(s[i] == ')'){
            char c = 'a';
            while(m.count(c) > 0){
                c++;
            }
            m[c] = megold(uj);
            uj.clear();
            for(int j = 0; j < s.size(); j++){
                if(j < going || j > i){
                    uj += s[j];
                }
                else{
                    uj += c;
                    j = i;
                }
            }
            return megold(uj);
        }
        if(going > -1){
            uj += s[i];
        }
        if(s[i] == '('){
            uj.clear();
            going = i;
        }
    }
    for(int i = 0; i < s.size(); i++){
        if(s[i] == '*'){
            char c = 'a';
            while(m.count(c) > 0){
                c++;
            }
            m[c] = m[ s[i-1] ] * m[ s[i+1] ];
            s[i] = c;
            s.erase(s.begin()+i+1);
            s.erase(s.begin()+i-1);
            i-=2;
        }
    }
    //cout<<s<<" ";
    int osszeg = m[s[0]];
    for(int i = 2; i < s.size(); i+=2){
        if(s[i-1] == '+'){
            osszeg+=m[s[i]];
        }
        else
            osszeg-=m[s[i]];
    }
    //cout<<osszeg<<"\n";
    return osszeg;
}
bool backtrack(int index){
    sort(sor.begin(), sor.end());
    do
    {
        bead();
        //cout<<megold(s1)<<"\n";
        if(megold(s1) == desired)
            return true;
    }
    while(next_permutation(sor.begin(), sor.end()));
    return false;
}
int main()
{
    cin.sync_with_stdio(false);
    cin.tie(0);
    int n;
    cin>>n;
    while(n != 0){
        m.clear();
        sor.clear();
        volt.clear();
        sor.resize(n);
        volt.resize(n);
        for(int i = 0; i < n; i++){
            cin>>sor[i];
            volt[i] = 0;
        }
        m['0'] = 0;
        cin>>desired>>s1;

        if(backtrack(0))
            cout<<"YES\n";
        else
            cout<<"NO\n";
        cin>>n;
    }
    cin>>n;
    return 0;
}
