#include <iostream>
#include <vector>

using namespace std;

int st[1000000][21] = {};

void CalculateST(int n)
{
    for(int i = 1; i < 21; i++)
    {
        for(int j = 0; j < n; j++)
        {
            if(j-(1<<(i-1)) < 0)
                continue;
            st[j][i] = min(st[j][i-1], st[j-(1<<(i-1))][i-1]);
        }
    }
    return;
}

int Ertek(int l, int r)
{
    int x = r-l+1, y = 0;
    while(x >= (1<<(y+1)))
        y++;
    return min(st[r][y], st[l+(1<<y)-1][y]);
}

int main()
{
    cin.sync_with_stdio(false);
    cin.tie(0);

    int n;
    while(cin>>n)
    {
        if(n == 0)
            break;

        vector<int> v(n);
        for(int i = 0; i < n; i++)
            cin>>v[i];

        for(int i = 1; i < n; i++)
            v[i] += v[i-1];
        for(int i = 0; i < n; i++)
            st[i][0] = v[i];

        CalculateST(n);

        int meg = 0;
        if(Ertek(0, n-1) >= 0)
            meg++;

        for(int i = 1; i < n; i++)
        {
            if((Ertek(i, n-1) - v[i-1] >= 0) && (Ertek(0, i-1) + v[n-1] - v[i-1] >= 0))
                meg++;
        }
        cout<<meg<<"\n";
    }

    return 0;
}
