#include <bits/stdc++.h>

using namespace std;

int vars[30];
int ind[30];


int eval(const string& s){
	stack<char> op;
	stack<int> val;
	
	for(auto c : s){
		if(c == '+' || c == '-' || c == '*')
			op.push(c);
		else if(c == ')'){
			int a = val.top();
			val.pop();
			int b = val.top();
			val.pop();
			switch (op.top()){
				case '+':
					val.push(a+b);
					break;
				case '-':
					val.push(b-a);
					break;
				case '*':
					val.push(b*a);
					break;
			}
			op.pop();
		} else if(c != '('){
			val.push(vars[ind[c-'a']]);
		}
	}
	assert(val.size() == 1);
	return val.top();
}

int main() {

#ifndef ONLINE_JUDGE
	//freopen("in.1", "r", stdin);
#endif
	
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);
	cout.tie(nullptr);
	
	
	int N;
	while(cin>>N && N > 0){	
		
		for(int i = 0; i < N; ++i)
			ind[i] = i;
		
		for(int i = 0; i < N; ++i){
			cin>>vars[i];
		}
		
		int target;
		cin>>target;
		
		cin.ignore(100, '\n');
		string str;
		cin>>str;
		
		bool ok = false;
		do{
			if(eval(str) == target){
				cout<<"YES\n";
				ok = true;
			break;
			}
			
		} while (next_permutation(ind, ind+N));
	
		if(!ok)
			cout<<"NO\n";
	}
	return 0;
}


