#include <bits/stdc++.h>

using namespace std;

const int MAXN = 1e6;
constexpr int LOGMAXN = ceil(log2(MAXN));

int v[2*MAXN], s[2*MAXN+1], logtable[2*MAXN+1], sparse_t[LOGMAXN+1][2*MAXN+1];


int main() {

#ifndef ONLINE_JUDGE
	freopen("in.1", "r", stdin);
#endif
	
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);
	cout.tie(nullptr);
	
	
	logtable[1] = 0;
		
	for (int i = 2; i <= 2*MAXN; i++) {
		logtable[i] = logtable[i/2] + 1;
	}
	
	
	int n;
	while (scanf("%d", &n) == 1 && n > 0) {

		for (int i = 0; i < n; i++) {
			int x;
			scanf("%d", &x);
			
			v[i] = v[i+n] = x;
		}
		
		s[0] = 0;
		for (int i = 0; i < 2*n; i++) {
			s[i+1] = s[i] + v[i];
		}
		
		
		// setup
		for (int i = 0; i <= 2*n; i++)
			sparse_t[0][i] = s[i];
			
		for (int j = 1; (1 << j) <= 2*n; j++) {	
			int i;
			for (i = 0; i <= 2*n && i + (1 << j) <= 2*n; i++) {
				sparse_t[j][i] = min(sparse_t[j-1][i], sparse_t[j-1][ i + (1 << (j-1)) ]);
			}
			
			while (i <= 2*n) {
				sparse_t[j][i] = sparse_t[j][i-1];
				i += 1;
			}
		}
		
		int ans = 0;
		
		for (int k = 0; k < n; k++) {
				
			int minim = min(
				sparse_t[ logtable[n] ][ k + 1 ],
				sparse_t[ logtable[n] ][ n + k - (1 << logtable[n]) + 1]
			);
			
			//printf("minim = %d\n", minim);
			//printf("s[k=%d] = %d\n", k, s[k]);
			
			if (minim - s[k] >= 0)	
				ans += 1;
		}
		
		printf("%d\n", ans);
	}
		
	return 0;
}


