import java.util.Scanner;

class City{
    private int people, boxes;
    private double max;
    private boolean maxNotInt;

    public City(int people) {
        this.people = people;
        boxes = 1;
        max = people;
        maxNotInt = false;
    }

    public void addBox(){
        boxes++;
        max = ((double)people) / boxes;
    }

    public double getMax() {
        return max;
    }
}

class Ballot{
    int numOfC;
    City[] cities;

    public Ballot(int numOfC, City[] cities) {
        this.numOfC = numOfC;
        this.cities = cities;
    }

    public int getMaxIndex(){
        double max = -1.0;
        int index = -1;
        for(int i = 0; i < cities.length; i++){
            if(cities[i].getMax() > max){
                max = cities[i].getMax();
                index = i;
            }
        }
        return index;
    }

    public int getMax(){
        double max = -1.0;
        for(int i = 0; i < cities.length; i++){
            if(cities[i].getMax() > max){
                max = cities[i].getMax();
            }
        }
        return (int)Math.ceil(max);
    }

    public void AddBox(){
        cities[this.getMaxIndex()].addBox();
    }
}

public class D {
    public static void main(String[] args) {
        Scanner sc = new Scanner(System.in);
        for(String line = sc.nextLine(); !line.equals("-1 -1"); line = sc.nextLine()){
            String[] data = line.split(" ");
            int numOfC = Integer.parseInt(data[0]);
            int numOfBoxes = Integer.parseInt(data[1]);
            City[] cities = new City[numOfC];
            for(int i = 0; i < numOfC; i++){
                cities[i] = new City(Integer.parseInt(sc.nextLine()));
            }
            Ballot spain = new Ballot(numOfC, cities);
            for(int i = 0; i < numOfBoxes-numOfC; i++){
                spain.AddBox();
            }
            System.out.println(spain.getMax());
            line = sc.nextLine();
        }
    }
}
