import java.util.*;

class Hivas {
    int start;
    int end;

    Hivas(int a, int b, int start, int end) {
        this.start = start;
        this.end = start + end;
    }
}

class Hallgatas {
    int start;
    int end;
    int darab;

    Hallgatas(int start, int end) {
        this.start = start;
        this.end = start + end;
        this.darab = 0;
    }
}

public class Happy {
    public static void main(String[] args) {
        int numberOfCalls, numberOfIntervals;

        List<Hivas> adatok = new ArrayList<>();
        List<Hallgatas> adatok2 = new ArrayList<>();

        Scanner sc = new Scanner(System.in);
        sc.useLocale(Locale.ENGLISH);

        try {
            while (true) {
                numberOfCalls = sc.nextInt();
                numberOfIntervals = sc.nextInt();

                if (numberOfCalls == 0 && numberOfIntervals == 0) break;

                adatok.clear();
                adatok2.clear();

                for (int i = 0; i < numberOfCalls; ++i) {
                    adatok.add(new Hivas(sc.nextInt(), sc.nextInt(), sc.nextInt(), sc.nextInt()));
                }
                for (int i = 0; i < numberOfIntervals; ++i) {
                    adatok2.add(new Hallgatas(sc.nextInt(), sc.nextInt()));
                }

                for (Hivas hi: adatok) {
                    for (Hallgatas ha : adatok2) {
                        if(!(hi.end <= ha.start || ha.end <= hi.start)) ha.darab++;
                    }
                }

                for (Hallgatas ha : adatok2) {
                    System.out.println(ha.darab);
                }
            }
        } catch (Exception ignored) { }
        sc.close();
    }
}
